﻿using Cp.Core;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Reflection;
using System.Reflection.Emit;
using System.Text;
using System.Threading.Tasks;

namespace Cp.EmitStudy
{    
    class Test2:ITest
    {
        class Model
        {
            public string Name { get; set; }
        }

        class ViewModel
        {
            public string Name { get; set; }
        }

        public string Name
        {
            get
            {
                return "Linq Assign Expression Test";
            }
        }

        public string Description
        {
            get
            {
                return "This demo demenstrates how to use Linq Expression to mapping properties between two object.";
                //return "此示例展示了如何利用Linq Expression将两个对象的属性进行映射";
            }
        }

        public void Test()
        {
            Expression<Func<Model, string>> exp1 = m => m.Name;
            Expression<Func<ViewModel, string>> exp2 = vm => vm.Name;
            var assignExp = Expression.Assign(exp2.Body, exp1.Body);
            var mapAction = Expression.Lambda<Action<Model, ViewModel>>(assignExp, exp1.Parameters[0], exp2.Parameters[0]).Compile();

            var m1 = new Model() { Name = "MODEL's Name" };
            var m2 = new ViewModel();
            mapAction(m1, m2);
            Console.WriteLine(m2.Name);
        }        
    }   
} 